@version 2.3
@script master
@save relative
@warnings
// Copyright 2005 Michael Green
// MikesLscripts@shortbutpurple.fsnet.co.uk
//

myversion=3.2;

//3.2 fixed slight loading bug which showed when user cleared items from the scene.
//3.1 uses new id fixes in LW to make things more reliable.

//v3
// Added in very basic render layers scene saving, which toggles unseen by camera on/off for each layer 
// and also saves a default scene with any items in a layer set to unseen, other items left as is.

//v2.8
// Fixed Copy/Paste/Save/Load crash.

//v2.7
// List layers of selected items now opens a panel, and you can select items in it. 

//v2.6
// fixed clearing multiple items and children.

//v2.5
// fixed disparity between icons and states.

//v2.4
// added matte options.

//v2.3
// fixed a bug to do with saving layers/copying layers

//v2.2
// fixed a bug to do with panels in Show items layer

//v2.1
// Saves main panel position/size in scene file. 

//v2.0
// Added item selection in contents panel and removal button. 

//v1.9
// added keyboard support for item selection

//v1.8
// Added keyboard support.

//v1.7
// fixed bug in bone saving.

// v 1.6
// fixed load from scene bug

//v1.5
// changed how states are stored, big code change. When items are added
// to a layer, they now take on the attributes of that layer, and when 
// one attribute of a layer is changed, all item's attributes are refreshed.  

//v1.4
//fixed loading of items bug which must have come in 1.3 >:P

// V1.3
// Made universal to 9> and 9. Fixed a couple of bugs including saving of 12 items bug.

// V1.2
//Fixed layer reference problem. God knows how it seemed to work in the first place!

// V1.1
//Fixed mac file problem

// V1
//First full version
t1,l1,b9,b10,b11,h1,h2;
hk2,hk3,hk4,hk5;  //hotkey globals

//display types
hide=1;
bbox=2;
vrtx=3;
wire=4;
face=5;
shad=6;
txtd=7;


//Layer data structure
instancename="Default";
layers;

tabnames;
disp=1;
rend=2;
sele=3;

listheadings;

dname=1;       //Layer name
dlist=2;       //Layer list of OA
state=3;       //Layer State

dspst=1;
lockd=2;

rname=1;
rlist=2;

//render options
selfs=1;
casts=2;
reces=3;
uncam=4;
unray=5;
unfog=7;
matte=6;

unlk=0;
lokd=1;

no=1;
yes=2;
yesno;

loadedlayers=nil;            // used for loading in
quicklist;                  //global list for quicksort
statetype;
gheadings="Layers";
myselected=nil;               // Array of ints which are the selected layer numbers
globalindex;                  //stores which current layer we're playing with
currentselection=nil;         //stores list of currently selected OA in layout

gitemsold=nil; 					// List of items used for Display layers of items code.

icons;
mytab=1;                          // current selected tab;

greqw=222;
greqh=272;
greqx=10;
greqy=10;

list1;   //layer contents ctl

hotkeys;
HKStart=32;
disableHK=0;

DefaultHotkeys
{
	for(i=1;i<=126-HKStart;i++)
	{
		hotkeys[i]=nil;
	}
}



CreateLayer:playertype,pname
{
    temp[dname]=pname;           //Layer Name
    temp[dlist]=nil;                 // list of items.

    if(playertype==disp)
    {
        temp[state][dspst]=txtd;                   // Diplay state
        temp[state][lockd]=unlk;                   // Locked/unlocked
    }
    else if(playertype==rend)
    {
        temp[state][unray]=0;                   // Unseen by rays
        temp[state][uncam]=0;                   // Unseen by camera
        temp[state][unfog]=0;                   // Unseen by fog
        temp[state][selfs]=1;                   // Self Shadow
        temp[state][casts]=1;                   // Cast Shadow
        temp[state][reces]=1;                   // Receive Shadow
        temp[state][matte]=0;                   // Matte
    }

    else if(playertype==sele)
    {
		temp[state][1]=0;
		temp[state][2]=0;
    }
    return(temp);
}

CreateIcons
{
//===============================================================
// ICONS
    icons[rend][1][uncam]="Camera";
    icons[rend][1][unray]="Rays";
    icons[rend][1][unfog]="Fog";
    icons[rend][1][matte]="Matte";
    icons[rend][1][selfs]="SelfS";
    icons[rend][1][casts]="CastS";
    icons[rend][1][reces]="ReceS";
    if(hostVersion()<11)
    {
        icons[disp][1][hide]="Hide";
        icons[disp][1][bbox]="Bbox";
        icons[disp][1][vrtx]="Vrtx";
        icons[disp][1][wire]="Wire";
        icons[disp][1][face]="Face";
        icons[disp][1][shad]="Shad";
        icons[disp][1][txtd]="Text";
        icons[disp][2][unlk+1]="Unlk";
        icons[disp][2][lokd+1]="Lock";
        icons[4][1]="O";
        icons[4][2]="B";
        icons[4][3]="L";
        icons[4][4]="C";
    }
    else
    {
        Icon_Hide = @
                        ".1...1..1..1..1.",
                        "................",
                        "................",
                        ".1............1.",
                        "................",
                        "................",
                        ".1............1.",
                        "................",
                        "................",
                        ".1............1.",
                        "................",
                        "................",
                        "................",
                        ".1...1..1..1..1."
                    @;
    
        Icon_Bbox = @
                        ".11111111111111.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".1............1.",
                        ".11111111111111."
                    @;
    
        Icon_Vrtx = @   
                        ".11....11....11.",
                        ".11....11....11.",
                        "................",
                        "....11....11....",
                        "....11....11....",
                        "................",
                        ".11....11....11.",
                        ".11....11....11.",
                        "................",
                        "....11....11....",
                        "....11....11....",
                        "................",
                        ".11....11....11.",
                        ".11....11....11."
                    @;
    
        Icon_Wire = @   
                        ".11111111111111.",
                        ".11111111111111.",
                        ".111...11...111.",
                        ".11.1..11..1.11.",
                        ".11..1.11.1..11.",
                        ".11...1111...11.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11...1111...11.",
                        ".11..1.11.1..11.",
                        ".11.1..11..1.11.",
                        ".111...11...111.",
                        ".11111111111111.",
                        ".11111111111111."
                    @;
    
        Icon_Face = @
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11....11....11.",
                        ".11....11....11.",
                        ".11....11....11.",
                        ".11....11....11.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11....11....11.",
                        ".11....11....11.",
                        ".11....11....11.",
                        ".11....11....11.",
                        ".11111111111111.",
                        ".11111111111111."
                    @;
    
        Icon_Shad = @   
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111."
                    @;
    
        Icon_Text = @   
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".111........111.",
                        ".111........111.",
                        ".111111..111111.",
                        ".111111..111111.",
                        ".111111..111111.",
                        ".111111..111111.",
                        ".111111..111111.",
                        ".111111..111111.",
                        ".11111111111111.",
                        ".11111111111111.",
                        ".11111111111111."
                    @;
    
        Icon_Obj = @
                        "................",
                        ".....**********.",
                        "....*........**.",
                        "...*........*.*.",
                        "..*........*..*.",
                        ".**********...*.",
                        ".*........*...*.",
                        ".*........*...*.",
                        ".*........*...*.",
                        ".*........*..*..",
                        ".*........*.*...",
                        ".*........**....",
                        ".**********.....",
                        "................"@;
    
        Icon_Bone=@
                        "................",
                        ".....11.........",
                        "....1..1........",
                        "...11..1........",
                        "..1....1........",
                        "..1.....1.......",
                        "...111...1......",
                        "......1...111...",
                        ".......1.....1..",
                        "........1....1..",
                        "........1..11...",
                        "........1..1....",
                        ".........11.....",
                        "................"@;
        
        Icon_Light=@
                        "................",
                        "...........1....",
                        "..........1.....",
                        ".........1......",
                        "..1111111.......",
                        "..1.....1.......",
                        "..1.....1.......",
                        "..1.....1.......",
                        "..1.....1.......",
                        "..1111111.......",
                        ".........1......",
                        "..........1.....",
                        "...........1....",
                        "................"@;
    
        Icon_Camera=@
                        "................",
                        "...111.111......",
                        "..1...1...1.....",
                        ".1.........1....",
                        ".1.........1....",
                        "..1.......1.....",
                        "...1111111......",
                        "...1.....1..11..",
                        "...1.....111.1..",
                        "...1.....1...1..",
                        "...1.....111.1..",
                        "...1.....1..11..",
                        "...1111111......",
                        "................"@;
    
        Icon_Unlock=@
                        "................",
                        "..111111........",
                        ".1......1.......",
                        ".1.1111.1.......",
                        ".1.1..1.1.......",
                        ".1.1..1.1.......",
                        ".111.1111111111.",
                        ".....1........1.",
                        ".....1..1111..1.",
                        ".....1...11...1.",
                        ".....1...11...1.",
                        ".....1........1.",
                        ".....1111111111.",
                        "................"@;

        Icon_Lock=@
                        "................",
                        ".....111111.....",
                        "....1......1....",
                        "....1.1111.1....",
                        "....1.1..1.1....",
                        "....1.1..1.1....",
                        "...1111111111...",
                        "...1........1...",
                        "...1..1111..1...",
                        "...1...11...1...",
                        "...1...11...1...",
                        "...1........1...",
                        "...1111111111...",
                        "................"@;
    
    icons[disp][1][hide]=Icon(Icon_Hide);
    icons[disp][1][bbox]=Icon(Icon_Bbox);
    icons[disp][1][vrtx]=Icon(Icon_Vrtx);
    icons[disp][1][wire]=Icon(Icon_Wire);
    icons[disp][1][face]=Icon(Icon_Face);
    icons[disp][1][shad]=Icon(Icon_Shad);
    icons[disp][1][txtd]=Icon(Icon_Text);
    icons[disp][2][unlk+1]=Icon(Icon_Unlock);
    icons[disp][2][lokd+1]=Icon(Icon_Lock);
    icons[4][1]=Icon(Icon_Obj);
    icons[4][2]=Icon(Icon_Bone);
    icons[4][3]=Icon(Icon_Light);
    icons[4][4]=Icon(Icon_Camera);
    }
}

create
{
    setdesc("LayersMC:"+instancename);
    DefaultHotkeys();
    myselected[1]=1;
    
    tabnames[disp]="Display";
    tabnames[rend]="Render";
	tabnames[sele]="Select";

    layers[disp][1]=CreateLayer(disp,"Display1");
    layers[rend][1]=CreateLayer(rend,"Render1");
    layers[sele][1]=CreateLayer(sele,"Select1");

    listheadings[disp]="Layers";
    listheadings[rend]="Layers";
    listheadings[sele]="Layers";

    statetype[disp][dspst][1]="Blank because it's offset";
    statetype[disp][dspst][hide+1]="[Hide]";
    statetype[disp][dspst][bbox+1]="[BBox]";
    statetype[disp][dspst][vrtx+1]="[Vrtx]";
    statetype[disp][dspst][wire+1]="[Wire]";
    statetype[disp][dspst][face+1]="[Face]";
    statetype[disp][dspst][shad+1]="[Shade]";
    statetype[disp][dspst][txtd+1]="[Text]";

    statetype[disp][lockd][1]="Blank because it's offset";
    statetype[disp][lockd][unlk+1]="[Unlk]";
    statetype[disp][lockd][lokd+1]="[Lock]";

    statetype[rend][uncam][1]="C";    statetype[rend][uncam][2]="X";
    statetype[rend][unray][1]="R";    statetype[rend][unray][2]="X";
    statetype[rend][unfog][1]="F";    statetype[rend][unfog][2]="X";
    statetype[rend][matte][1]="X";    statetype[rend][matte][2]="M";
    statetype[rend][selfs][1]="XX";   statetype[rend][selfs][2]="SS";
    statetype[rend][casts][1]="XX";   statetype[rend][casts][2]="CS";
    statetype[rend][reces][1]="XX";   statetype[rend][reces][2]="RS";

    statetype[sele][1]=" ";
    statetype[sele][2]=" ";

    CreateIcons();
    
}

reqkeyboard:key
{
// selection
	if(disableHK)
		return;

    if(key == REQKB_F1)
			SelectByType(MESH);
	else if(key == REQKB_F2)
			SelectByType(BONE);
	else if(key == REQKB_F3)
			SelectByType(LIGHT);
	else if(key == REQKB_F4)
			SelectByType(CAMERA);

// + - layer
    else if(key == REQKB_HOME)
			AddToLayer();
	else if(key == REQKB_END)
			RemoveFromLayer;

//layer commands
	else if(key == REQKB_INSERT)	Choice(1);		//AddLayer();
	else if(key == REQKB_PAGEUP)	Choice(2);		//RenameLayer();
	else if(key == REQKB_RIGHT)     Choice(3);		//LayerContents();
	else if(key == REQKB_F5)        Choice(5);		//SelectItemLayer();
	else if(key == REQKB_F9)        RenderFrame();	//Choice(8);		//ClearLayerItems();
	else if(key == REQKB_DELETE)    Choice(9);		//DeleteLayer();
	else if(key == REQKB_F6)        Choice(11);		//copy selected --CopyLayers(1,1);
	else if(key == REQKB_F7)		Choice(12);		//copy all --CopyLayers(1,0);
	else if(key == REQKB_F8)		Choice(13);		//PasteLayers(1);
	else if(key == REQKB_F10)     	RenderScene();	//Choice(15);		//Save Selected -- CopyLayers(0,1);
	else if(key == REQKB_F11)   	RenderSelected();//Choice(16);		//Save all --	CopyLayers(0,0);
	else if(key == REQKB_F12)       Model();			//Choice(17);		//PasteLayers(0);

    else if(key-HKStart<hotkeys.size() && key-HKStart>0 && hotkeys[key-HKStart]!=nil)
		{
			myvals=parse(":",hotkeys[key-HKStart]);
			mytab=myvals[1].asInt();
			setvalue(t1,mytab);

			templayer=myvals[2];


			tempitem=myvals[3].asInt();

			found=0;
			for(i=1;i<=layers[mytab].size();i++)
			{
        	  	if(layers[mytab][i][dname]==templayer)
        	  	{
					found=1;
    				for(j=1;j<=myselected.size();j++)
    				{
        				myselected[j]=nil;
    				}
    				myselected[1]=i;
    				myselected.trunc();
					setvalue(l1,myselected);
					SelectByType(tempitem);
				}
			}
			if(!found)
				hotkeys[key-HKStart]=nil;

		}
	if(key!=REQKB_SHIFT && key!=REQKB_CTRL)
		requpdate();
}

options
{
    temp[1]=1;
    myselected=temp;

    mytab=1;

    mychoice[1]="Create new layer                <Ins>";
    mychoice[2]="Rename layer                    <PageUp>";
    mychoice[3]="View contents of layer          <Right>";
    mychoice[4]="===============";
    mychoice[5]="Find layer of selected item     <F5>";
    mychoice[6]="Choose instance name";
    mychoice[7]="Edit item selection hotkeys";
    mychoice[8]="Clear layer items from scene    ";
    mychoice[9]="Delete selected layers          <Del>";
    mychoice[10]="===============";
    mychoice[11]="Copy selected layers           <F6>";
    mychoice[12]="Copy all layers                <F7>";
    mychoice[13]="Paste layers                   <F8>";
    mychoice[14]="===============";
    mychoice[15]="Save selected layers           ";
    mychoice[16]="Save all layers                ";
    mychoice[17]="Load layers                    ";

    myhelp=HelpUDF();

    if(reqisopen())
        reqabort();

    reqbegin("LayersMC V:"+myversion.asStr()+":"+instancename);
    reqsize(greqw,greqh);
    reqposition(greqx,greqy);

    t1 = ctltab(tabnames);
    ctlposition(t1,0,0);

//===========================================================================
// ICONS

// Visibility options.
	dopt=@"hide","bbox","vrtx","face","shad","txtd"@;
	ddisp=@hide,bbox,vrtx,face,shad,txtd@;

	for(i=1;i<=dopt.size();i++)
    {
		d[i] = ctlbutton(icons[disp][dspst][ddisp[i]].asStr(),25,"StateTo","dspst,"+dopt[i]);
    	ctlposition(d[i],1,20*i,40,20);
	}

//-------------------------------------------------------------------------

// Select by type

    i1 = ctlbutton(icons[4][1].asStr(),24,"SelectByType","MESH");   	ctlposition(i1,1,165,24,20);
	i2 = ctlbutton(icons[4][2].asStr(),24,"SelectByType","BONE");		ctlposition(i2,24,165,24,20);
    i3 = ctlbutton(icons[4][3].asStr(),25,"SelectByType","LIGHT");	    ctlposition(i3,1,185,24,20);
    i4 = ctlbutton(icons[4][4].asStr(),25,"SelectByType","CAMERA");    	ctlposition(i4,24,185,24,20);

//----------------------------------------------------------------------------

// Item Lock

    b8 = ctlbutton(icons[disp][lockd][lokd+1].asStr(),34,"StateTo","lockd,2");    	ctlposition(b8,1,205,47,20);
    b12 = ctlbutton("SvRS",50,"SaveRenderScenes","1");    								ctlposition(b12,1,205,47,20);
    b13 = ctlbutton("SvSS",50,"SaveRenderScenes","0");    								ctlposition(b13,1,225,47,20);


//--------------------------------------------------------------------------

// render options
	ropt[uncam]="uncam"; ropt[unray]="unray";ropt[matte]="matte"; ropt[unfog]="unfog"; 
	ropt[selfs]="selfs"; ropt[casts]="casts";ropt[reces]="reces";
	for(i=1;i<ropt.size();i++)
    {
		r[i] = ctlbutton(icons[rend][dname][i].asStr(),30,"StateTo",ropt[i]+",2");   	ctlposition(r[i],1,20*i,45,20);
	}

    b9 = ctlbutton("+ to Lyr",34,"AddToLayer");
    b10 = ctlbutton("- to Lyr",34,"RemoveFromLayer");
    b11 = ctlmenu("Layer>",mychoice,"Choice");

    l1 = ctllistbox(gheadings,greqw - 65,greqh - 44,
                    "ListSize","ListItem","ListSelected");

    h1 = ctlpopup("?",1,myhelp[1]);
    h2 = ctlpopup("?",1,myhelp[2]);
    ctlrefresh(t1,"ChangeTab");

    ctlpage(1,d[1],d[2],d[3],d[4],d[5],d[6],b8,h1);           //display layers.
    ctlpage(2,r[1],r[2],r[3],r[4],r[5],r[6],h2,b12,b13);                 //renderlayers. Need fog to be added to sdk
//    ctlpage(3,t1);

    reqresize("Resize");
    reqopen("GetPosition",500);

//    ctlactive(l1d,"DispActive",d1,d2,d3,d4,d5,d6,i1,i2,i3,i4,b7,b8,b9d,b10d);
}


GetPosition
{
	(greqx,greqy)=reqposition();
}

HelpUDF
{
    help[1][1]="State";
    help[1][2]="The 6 buttons down the left side of the panel";
    help[1][3]="allow you to choose which display mode items";
    help[1][4]="are displayed in. Hide will hide all items";
    help[1][5]="including bones, cameras and lights, while";
    help[1][6]="any of the other modes will unhide bones,";
    help[1][7]="cameras and lights.";
    help[1][8]="Items.('F1','F2','F3','F4'  keys)";
    help[1][9]="The four buttons down the left in the middle";
    help[1][10]="select the items of that type belonging to";
    help[1][11]="the selected layers.";
    help[1][12]="Add Items. ('Home' key)";
    help[1][13]="Adds selected items to the last selected layer.";
    help[1][14]="Remove Items.('End' key)";
    help[1][15]="Removes selected items from layers.";

    help[2][1]="State";
    help[2][2]="The 6 buttons down the left side of the panel";
    help[2][3]="allow you to choose which toggles items";
    help[2][4]="are rendered with.";
    
    return(help);
}

Resize:w,h
{
	greqw=w;
	greqh=h;
	(greqx,greqy)=reqposition();

    ctlposition(l1,50,20,w - 65,h - 44);
    ctlposition(b9,50,h - 22 ,50,20);
    ctlposition(b10,99,h - 22,50,20);
    ctlposition(b11,157,h - 22,50,20);
    ctlposition(h1,1,h - 22,40,20);
    ctlposition(h2,1,h - 22,40,20);

}

ChangeTab:value
{
    mytab = getvalue(t1);
    for(i=1;i<=myselected.size();i++)
    {
        myselected[i]=nil;
    }
    myselected[1]=1;
    myselected.trunc();

    gheadings=listheadings[mytab];
//    setvalue(l1,0);
    requpdate();
}
//===================================================================================================
//===================================================================================================

// DISPLAY LAYERS 

ListSize
{
    return (layers[mytab].size());
}

ListItem: index
{
    tempstate=layers[mytab][index][state];
    tempname= layers[mytab][index][dname];

    myline="";

    for(i=1;i<=statetype[mytab].size();i++)
    {
        statename=statetype[mytab][i][tempstate[i]+1];
        myline=myline + statename + "  ";
    }

    myline=myline+tempname;
    return (myline);
}

ListSelected : selected
{
    myselected=selected;
    return;
}



//===========================================================================================================
// DISP DROP DOWN MENU
Choice: item
{
    if((item==2 || item==3 || item==8 || item==9 || item==11 || item==15) && !myselected[1])
    {
		warn("Please select one or more layers.");
        return;
    }

		reqabort();
		disableHK=1;
//debug();
    switch(item)
    {
        case 1:
            AddLayer();
        break;

        case 2:                                                 //rename layer
            RenameALayer();
        break;

        case 3:                                                 //contents of layer
            LayerContents();
        break;

        case 5:
            ShowItemLayer();                                                 //find layer of object
        break;

        case 6:
            reqend();
            ChangeInstanceName();
            process(0,0);
            options();
        break;

        case 7:
//            info("ChooseHotkeys");
            ChooseHotkeys();
        break;

        case 8:
//            info("Clear layer items from scene");
            ClearLayerItems();
        break;

        case 9:
            DeleteLayer();
        break;

        case 11:
//            info("Copy selected Layers");
            CopyLayers(1,1);
        break;

        case 12:
//            info("Copy All Layers");
            CopyLayers(1,0);
        break;

        case 13:
//            info("PasteLayers");
            PasteLayers(1);
        break;

        case 15:
//            info("Save selected Layers");
            CopyLayers(0,1);
        break;

        case 16:
//            info("Save All Layers");
            CopyLayers(0,0);
        break;

        case 17:
//            info("LoadLayers");
            PasteLayers(0);
        break;

        default:
            info("Default"+item.asStr());
        break;
     }
	disableHK=0;
	options();
    requpdate();

}

//============================================================================================
// HotKeys

ChooseHotkeys
{
	mytemp=1;

	reqbegin("Choose Hotkeys");
	hk1=ctllistbox("Hotkeys assigned",200,300,"HotkeyCount","HotkeyName","HotkeyChoice");
	hk2=ctlpopup("Hotkey",1,"HotkeyKeyList");
	hk3=ctlpopup("LayerType",mytab,tabnames);
	hk4=ctlpopup("Layer",1,"HotkeyLayerList");
	hk5=ctlpopup("Item Type",1,@"Mesh","Lights","Cameras","Bones"@);
	hk6=ctlbutton("Assign",50,"AssignHotkey");
	
	ctlrefresh(hk3,"HotkeyTabRefresh");
	if (!reqpost())
	{
		return;
	}
	reqend();


}

HotkeyTabRefresh:value
{
  	temptab=value;
	HotkeyLayerList();
	setvalue(hk4,1);
	requpdate();
}
HotkeyCount
{
	return(hotkeys.size()-HKStart);
}

HotkeyName:index
{
	itemname=@"Meshes","Lights","Cameras","Bones"@;
	place=index + HKStart;
	mycharacter=place.asAsc();
	myname=mycharacter.asStr();
	if(hotkeys[index]!=nil)
	{

		myvals=parse(":",hotkeys[index]);
		temptab=myvals[1].asInt();
		templayer=myvals[2];
		tempitem=myvals[3].asInt();
		found=0;
		for(i=1;i<=layers[temptab].size();i++)
		{
          	if(layers[temptab][i][dname]==templayer)
				found=1;
		}
		if(found)
			myname=myname+"     "+tabnames[temptab]+" : "+myvals[2]+" : "+itemname[tempitem];
		else
			hotkeys[index]=nil;
	}
	return(myname);
}

HotkeyChoice:items
{
	myitem=items[1];
	setvalue(hk2,myitem);
	if(hotkeys[myitem])
	{
		myvals=parse(":",hotkeys[myitem]);
		temptab=myvals[1].asInt();
		templayer=myvals[2];
		tempitem=myvals[3].asInt();
		setvalue(hk3,temptab);
		setvalue(hk5,tempitem);
		found=0;
		for(i=1;i<=layers[temptab].size();i++)
		{
			tempname=layers[temptab][i][dname];
			if(tempname==templayer)
				setvalue(hk4,i);
		}
	}
	return;
}

HotkeyKeyList
{
	myarray[1]="b";
	for(i=33;i<=126;i++)
	{
		mychar=i.asAsc();
		myarray[i- HKStart]=mychar.asStr();
	}
	return(myarray);
}

HotkeyLayerList
{
	temptab=getvalue(hk3);
	myarray[1]="Blah";
	index=1;
	for(j=1;j<=layers[temptab].size();j++)
	{
		myarray[index]=layers[temptab][j][dname];
		index++;
	}
	return(myarray);
}

AssignHotkey
{
	mybutton=getvalue(hk2);
	temptab=getvalue(hk3);
	templayer=getvalue(hk4);
	tempgenus=getvalue(hk5);

	if(templayer<=layers[temptab].size())
		hotkeys[mybutton]=temptab.asStr()+":"+layers[temptab][templayer][dname]+":"+tempgenus.asStr();
	requpdate();
}

//==========================================================================================================
// Menu items

ChangeInstanceName
{

    reqbegin("New instance name?");
    s1=ctlstring("Name",instancename,150);
    if(!reqpost())
        return;
    instancename=getvalue(s1);
    reqend();
}

ClearLayerItems
{
    if(!myselected[1])
        return;
    reqbegin("Clear Layers' items from scene: Are you sure?");
    reqsize(400,30);
    if(!reqpost())
        return;
    reqend();

    AutoConfirm(1);
    for(i=1;i<=myselected.size();i++)
    {
        myitems=layers[mytab][myselected[i]][dlist];
        for(p=1;p<=myitems.size();p++)
        {
            SelectItem(myitems[p].id);
            ClearSelected();
        }
        layers[mytab][myselected[i]][dlist]=nil;
    }
    AutoConfirm(0);
}

AddLayer
{
    reqbegin("Layer Name");
    in1=ctlstring("","Layer",200);
    return if !reqpost();
    mylayername= getvalue(in1);
    reqend();
    
    listsize=layers[mytab].size();
    temp=CreateLayer(mytab,mylayername);
    layers[mytab][listsize+1]=temp;
}

DeleteLayer
{
    if(!myselected[1])
        return;

    if(layers[mytab].size()<=myselected.size())
    {
        info("Cannot delete the last layer");
        return;
    }

    reqbegin("Delete selected layers: Are you sure?");
    reqsize(350,30);
    if(!reqpost())
        return;

    reqend();

    p=1;
    myignore=0;
    for(i=1;i<=layers[mytab].size();i++)
    {
        for(j=1;j<=myselected.size();j++)
        {
            if(i==myselected[j]) //&&myselected[j]!=1)
            {
                myignore=1;
                break;
            }
        }
        if(!myignore)
        {
            temp_list[p]=layers[mytab][i];
            p++;
        }
        myignore=0;
    }
    layers[mytab]=temp_list;
}


RenameALayer
{
    if(!myselected[1])
    {
        return;
    }

    for(i=1;i<=myselected.size();i++)
    {
		mylayername=layers[mytab][myselected[i]][dname];
        reqbegin("Rename Layer");
        in1=ctlstring("",mylayername,200);
        return if !reqpost();
        
        mylayername= getvalue(in1);
        layers[mytab][myselected[i]][dname]=mylayername;
        reqend();
    }
}


//===========================================================================================
ShowItemLayer
{
    myitems=Scene().getSelect();
    if(!myitems)
         return;
	for(j=1;j<=myitems.size();j++)
	{
    	found=0;
		myitem=myitems[j];
    	for(i=1;i<=layers[mytab].size();i++)
    	{
        	result=FindIndex(myitem,layers[mytab][i][dlist]);
			results[j][1]=myitem;
        	if(result!=nil)
        	{
         		results[j][2]=myitem.name+" "+layers[mytab][i][dname];
         		found=1;
        	}
     	}
     	if(!found)
     		results[j][2]=myitem.name+" <none>";
 	}
 	gitemsold=results;
    reqbegin("Item layers");
    list1=ctllistbox("Item               Layer",200,260,
	 					"ItemContSize","ItemContItem","ItemContSelect");
	return if !reqpost();
    reqend();
}

ItemContSize
{
    return(gitemsold.size());
}

ItemContItem : item
{
    object=gitemsold[item][2];
    return(object);
}

ItemContSelect:items  // selects items in the scene which  are selected in the panel.
{
	if(items==nil)
		return;
	myitem=gitemsold[items[1]][1];
	SelectItem(myitem.id);
	itemtype=myitem.genus;
	for(i=2;i<=items.size();i++)
	{
		myitem=gitemsold[items[i]][1];
		if(myitem.genus==itemtype)
		{
			AddToSelection(myitem.id);
		}
	}
	RefreshNow();
}
//===========================================================================================
LayerContents
{
	i=1;
    while(myselected[1] && i<=myselected.size())
    {
        globalindex=myselected[i];
        mylayername=layers[mytab][myselected[i]][dname];
        reqbegin("Contents of Layer "+ mylayername);
        reqsize(200,320);
        list1=ctllistbox("Contents of Layer "+mylayername,170,260,
	 					"DispContSize","DispContItem","DispContSelect");
		button1=ctlbutton("Remove",150,"DispContRemoveFromLayer");
        reqpost();
        reqend();
        i++;
    }
}

DispContSize
{
    return(layers[mytab][globalindex][dlist].size());
}

DispContItem : item
{
    
    object=layers[mytab][globalindex][dlist][item];
    return(object.name);
}

DispContSelect:items  // selects items in the scene which  are selected in the panel.
{
	if(items==nil)
		return;
	mylayer=layers[mytab][globalindex];
	firstitem=mylayer[dlist][items[1]];
	SelectItem(firstitem.id);
	itemtype=firstitem.genus;
	for(i=2;i<=items.size();i++)
	{
		myitem=mylayer[dlist][items[i]];
		if(myitem.genus==itemtype)
		{
			AddToSelection(myitem.id);
		}
	}
	RefreshNow();
}

DispContRemoveFromLayer
{
	items=getvalue(list1);
	if(items==nil)
		return;
	RemoveFromLayer();

	requpdate();
}

CopyLayers:pcopy,puseselect
{
    if(puseselect && myselected[1]==nil)
        return;

    if(pcopy)
    {
        tempdir=getdir(TEMPDIR);
        myname=tempdir+"\\MGDisplaylayers.lyr";
    }
    else
    {
        tempdir=getdir(CONTENTDIR);
        myname=getfile("Save Layer File as","*.lyr",tempdir,0);
    }
    if(!myname)
        return;
    myfile=File(myname,"w");
    if(!myfile)
        return;

	if(puseselect)
	{
		for(j=1;j<=layers.size();j++)
		{
			myarray[j]=nil;
			if(j==mytab)
			{
    			for(i=1;i<=myselected.size();i++)
    			{
        			myarray[mytab][myselected[i]]=layers[mytab][myselected[i]];
    			}
   			}
		}
		myhotkeys=MakeHotkeyList(myarray);
 	}
	else
	{
		myarray=layers;
		myhotkeys=hotkeys;
	}
    SaveData(myarray,myhotkeys,myfile);
    myfile.close();
}

MakeHotkeyList:parray
{
	myhotkeys[1]=nil;
	for(j=1;j<=hotkeys.size();j++)
	{
		if(hotkeys[j])
		{
			myhotkeys[j]=nil;
			myhotkey=parse(":",hotkeys[j]);
			temptab=myhotkey[1].asInt();
			templayer=myhotkey[2];
			tempitem=myhotkey[3].asInt();
			layerfound=0;
			if(myarray[temptab]!=nil)
			{
				for(i=1;i<=parray[temptab].size();i++)
				{
					if(parray[temptab][i][dname]==templayer)
					{
						layerfound=1;
						break;
					}
				}
				if(layerfound)
					myhotkeys[j]=hotkeys[j];
			}
		}
	}
	return(myhotkeys);
}

PasteLayers:pcopy
{
    if(pcopy)
    {
        tempdir=getdir(TEMPDIR);
        myname=tempdir+"\\MGDisplaylayers.lyr";
    }
    else
    {
        tempdir=getdir(CONTENTDIR);
        myname=getfile("Save Layer File as","*.lyr",tempdir,1);
    }
    if(!myname)
        return;
    myfile=File(myname,"r");
    if(!myfile)
        return;

    if(myfile)
    {
        mydata=LoadData(myfile);
        myfile.close();
    }
    for(i=1;i<=mydata.size();i++)             // layer type
    {
        for(j=1;j<=mydata[i].size();j++)      // layer
        {
            if(i!=sele)
            	RemoveItemsFromLayers(mydata[i][j][dlist],i,);
        }
    }
    i=1;
    while(i<=mydata.size())
    {
        layercount=layers[i].size();
        j=1;
        while(j<=mydata[i].size())
        {
            layers[i][layercount+j]=mydata[i][j];
            j++;
        }
        i++;
    }
    StatusMsg("Layers pasted");
}

//======================================================================================================================

StateTo:poption,pval     // pval= 0 for off, 1 for on, 2 to toggle.
{
    if(!myselected[1])
        return;
    olditems=Scene().getSelect();

    for(i=1;i<=myselected.size();i++)
    {
        mylayer=myselected[i];
        if(!mylayer)
        	break;
        if(mylayer<=layers[mytab].size())
        {
            if(mytab==disp && poption==dspst)        // because display is 1-7.
                layers[mytab][mylayer][state][poption]=pval;
            else if (pval==2)
            {
                pison=!layers[mytab][mylayer][state][poption];
                layers[mytab][mylayer][state][poption]=pison;
            }
            else
                layers[mytab][mylayer][state][poption]=pval;
            items=layers[mytab][mylayer][dlist];
            mystate=layers[mytab][mylayer][state];
            RefreshItemFlags(items,mystate);
        }
    }
    requpdate();

    SelectOld(olditems);
}

RefreshItemFlags:pitems,pstate
{
    switch(mytab)
    {
        case disp:
            for(i=1;i<=pitems.size();i++)
            {
                myitem=pitems[i];
                SelectItem(myitem.id);
                    ItemVisibility(pstate[dspst]);
                if(myitem.locked > 0 && pstate[lockd] == unlk)  // Unlock items
        			CommandInput("ItemUnlock "+string(hex(myitem.id)));  // Post 9.6? or 9.5...
//                    ItemLock(1);       // Pre 9.6?
                else if(myitem.locked == 0 && pstate[lockd] ==lokd)     // Lock items
                    ItemLock(1);
            }
        break;

        case rend:
            for(i=1;i<=pitems.size();i++)
            {
                myitem=pitems[i];
                if(myitem.isMesh())
                {
                    SelectItem(myitem.id);

                    MakeMatte(myitem,(1 - pstate[matte])*2);
                    if(pstate[uncam]!=myitem.flags[uncam])
                        UnseenByCamera();
                    if(pstate[unray]!=myitem.flags[unray])
                        UnseenByRays();
                    if(pstate[selfs]!=myitem.flags[selfs])
                        SelfShadow();
                    if(pstate[casts]!=myitem.flags[casts])
                        CastShadow();
                    if(pstate[reces]!=myitem.flags[reces])
                        ReceiveShadow();
                }
            }
        break;
    }
}

MakeMatte:item,value
{
	if(item.genus!=MESH)
		return;
//	MatteObject();
//    MatteColor(<0,0,0>);
	mycom= "UnseenByAlphaChannel "+string((1 - value)*2);
	CommandInput(mycom);
}


SelectByType:mytype
{
    if(!myselected[1])
        return;
    objlist=nil;
    for(i=1;i<=myselected.size();i++)
    {

        templist=layers[mytab][myselected[i]][dlist];

        if(templist)
        {
            j=1;
            while(j<=templist.size() && templist[j].genus!=mytype)
                j++;
            if(j<=templist.size())
            {
                while(j<=templist.size() && templist[j].genus==mytype)
                {
                    objlist+=templist[j];
                    j++;
                }
            }
        }
    }

    SelectOld(objlist);
}


AddToLayer
{
    myitems=Scene().getSelect();
    currentselection=myitems;            // Must remember this, in case Layers started after selection made!
    worked=AddItemsToLayer(myitems,mytab,myselected[1]);
    if(!worked)
        return;
    itemcount=myitems.size();
    mystate=layers[mytab][myselected[1]][state];
    RefreshItemFlags(myitems,mystate);
    StatusMsg(itemcount.asStr() + " item(s) added to layer "+layers[mytab][myselected[1]][dname]);

    SelectOld(myitems);

}

AddItemsToLayer:pitems,ptab,player
{
    if(!pitems)
    {
        return(0);
    }
    if(!ptab)
    {
        StatusMsg("Error Tab");
        return(0);
    }
    if(!player)
    {
        StatusMsg("Error Layer");
        return(0);
    }
	if(ptab!=sele)
    	RemoveItemsFromLayers(pitems,ptab,);

    mylist=layers[ptab][player][dlist];// only adds items to 1st selected layer.
    if(pitems.size()>1)
    {
        quicklist=pitems;
        QSortByID(1,pitems.size());
        pitems=quicklist;
    }
    i=1;
    j=1;
    p=1;
    if(mylist)
    {
        while(i<=pitems.size()&&j<=mylist.size())
        {
            if(pitems[i].id<mylist[j].id)
            {
                mytemp[p]=pitems[i];
                i++;
            }
            else
            {
                if(pitems[i].id==mylist[j].id)
                    i++;
                mytemp[p]=mylist[j];
                j++;
            }
            p++;
        }
        while(i<=pitems.size())
        {
            mytemp[p]=pitems[i];
            i++;
            p++;
        }
        while(j<=mylist.size())
        {
            mytemp[p]=mylist[j];
            j++;
            p++;
        }

        layers[ptab][player][dlist]=mytemp;
    }
    else
    {
        layers[ptab][player][dlist]=pitems;
    }
    return(1);
}

RemoveFromLayer
{    
    myitems=Scene().getSelect();
    if(!myitems)
        return;
    if(mytab!=sele)
    	RemoveItemsFromLayers(myitems,mytab,);
    else if(myselected)
    	RemoveItemsFromLayers(myitems,mytab,myselected);
    
    SelectOld(objlist);
}

RemoveItemsFromLayers:pitems,ptab,players=nil
{
    // perform processing here
    if(players)
    	players.sortA();
    	
    for(i=1;i<=pitems.size();i++)
    {
        myitem=pitems[i];
        index=1;
        for(j=1;j<=layers[ptab].size();j++)
        {
			if(players==nil || (index<=players.size() && j==players[index]))
			{
            	layers[ptab][j][dlist]=RemFromList(myitem,layers[ptab][j][dlist]);
            	index++;
   			}
        }
    }
}

DispActive:value
{

    if (myselected[1])
        return(true);
    else
        return(false);
}
//==============================================================================================================
// Process function

process:event,command
{
    setdesc("LayersMC:"+instancename);
    if(event==COMMAND)
    {
        mycomm=parse(" ",command);

//=====================================================================================================
// Load section

//          if((mycomm[1]=="LoadScene" || mycomm[1]=="LoadFromScene") && loadedlayers)
//          {
//             RefreshNow();
//             for(i=1;i<=loadedlayers.size();i++)             // layer type
//             {
//                 for(j=1;j<=loadedlayers[i].size();j++)      // layer
//                 {
//                     myids=loadedlayers[i][j][dlist];
//                     loadedlayers[i][j][dlist]=ConvertIDs(myids);
//                 }
//             }
// 			for(i=1;i<=layers.size();i++)
// 			{
// 				if(loadedlayers.size()>=i && loadedlayers[i])
//             		layers[i]=loadedlayers[i];
//    			}
//             loadedlayers=nil;
//          }

//================================================================================================
// Remember selection for handling of Clearing items.

        if(mycomm[1]=="SelectItem" || mycomm[1]=="AddToSelection")
        {
            currentselection=Scene().getSelect();
        }

// clear selected items handling.

        if(mycomm[1]=="ClearSelected")
        {
        	ClearNilRefs();
        }
//=================================================================================================
    }
}

ClearNilRefs
{
    for(i=1;i<=layers.size();i++)
    {
		for(j=1;j<=layers[i].size();j++)
		{
			for(k=1;k<=layers[i][j][dlist].size();k++)
			{
				if(layers[i][j][dlist][k] && !layers[i][j][dlist][k].isValid())
                	layers[i][j][dlist][k]=nil;
			}
			layers[i][j][dlist].pack();
			if(layers[i][j][dlist][1]==nil)
			{
				layers[i][j][dlist][1]=1;
			}
			layers[i][j][dlist].trunc();
			if(layers[i][j][dlist][1]==1)
            	layers[i][j][dlist]=nil;
		}
	}
}
//==========================================================================================================
// File handling

load:what,io
{
    if(what==SCENEMODE)
    {
        layers=LoadData(io);
    }

}


save: what,io
{
   if(what==SCENEMODE)
   {
       SaveData(layers,hotkeys,io);
   }
}



SaveData:parray,photkeys,io
{

    io.writeln("MGLayersData");
    io.writeln("Instancename "+instancename);
    io.writeln("ReqPosition " + greqw.asStr() +" "+ greqh.asStr() +" "+ greqx.asStr() +" "+ greqy.asStr());

//===================================================
	for(p=1;p<=parray.size();p++)
	{
		layergroup=parray[p];
		if(layergroup!=nil)
		{
			io.writeln("MG"+tabnames[p]+"Layers");
//debug();
    		for(i=1;i<=layergroup.size();i++)
    		{
            	layer=layergroup[i];
            	if(!layer)
            		continue;
            	io.writeln("Layername " + layer[dname]);
            	io.writeln("Layeritems");
            	for(j=1;j<=layer[dlist].size();j++)
            	{
                	mytgt=layer[dlist][j];
                	if (!mytgt)
                    	io.writeln("0");
                	else
						io.writeln(mytgt.id);
            	}
            	io.writeln("EndLayeritems");
            	if(p==disp)
            	{
            		io.writeln("Layerstate " + layer[state][dspst].asStr());
            		io.writeln("Layerlock " + (layer[state][lockd] + 1).asStr());
            	}
            	else if(p==rend)
            	{
                	io.writeln("EndLayeritems");
                	io.writeln("Layercamera " + layer[state][uncam].asStr());
                	io.writeln("Layerrays " + layer[state][unray].asStr());
                	io.writeln("Layerfog " + layer[state][unfog].asStr());
                	io.writeln("Layerselfs " + layer[state][selfs].asStr());
                	io.writeln("Layercasts " + layer[state][selfs].asStr());
                	io.writeln("Layerreces " + layer[state][reces].asStr());
                	io.writeln("Layermatte " + layer[state][matte].asStr());
				}
				else if(p==sele)
				{
					//do nothing
				}
			}
        }
    }
	SaveHotkeys(io,photkeys);
    io.writeln("MGEndLayers");

}

SaveHotkeys:io,photkeys
{
    io.writeln("MGHotkeysStart");
    for(i=1;i<=photkeys.size();i++)
    {
		if(photkeys[i]!=nil)
		{
			charval=i+HKStart;
			myline=charval.asStr()+"^"+photkeys[i];
			io.writeln(myline);
		}
	}
    io.writeln("MGHotkeysEnd");
}

LoadData:io
{
    temptab=1;
    index=0;
    temp=io.read();
    myline=parse(" ",temp);
    while(myline[1]!="MGEndLayers")
    {
        if(myline[1]=="Instancename")
            instancename=myline[2];
        else if(myline[1]=="ReqPosition")
        {
			greqw=max(greqw,myline[2].asInt());
			greqh=max(greqh,myline[3].asInt());
			greqx=myline[4].asInt();
			greqy=myline[5].asInt();
		}

        else if(myline[1]=="MGDisplayLayers")
        {
            index=0;
            temptab=disp;
        }

        else if(myline[1]=="MGRenderLayers")
        {
            index=0;
            temptab=rend;
        }

        else if(myline[1]=="MGSelectLayers")
        {
            index=0;
            temptab=sele;
        }

        else if(myline[1]=="Layername")
        {
            index=index+1;
            myname=myline[2];
            for (i=3;i<=myline.size();i++)
            {
                myname=myname + " " + myline[i];
            }
            mydata[temptab][index]=CreateLayer(temptab,myname);
        }
        else if(myline[1]=="Layeritems")
        {
            j=1;
            for(t=1;t<=mylist.size();t++)
            {
                mylist[t]=nil;
            }
            mylist[1]="temp";
            mylist.trunc();
            mylist[1]=nil;

            myline=io.read();
            while(myline!="EndLayeritems")
            {
                myid=myline.asInt();
                if(myid==0)
                	mylist[j]=nil;
                else
									mylist[j]=GetAgentByID(myid);
                myline=io.read();
                j++;
            }
            mydata[temptab][index][dlist]=mylist;
        }

        else if(myline[1]=="Layerstate") 	mydata[temptab][index][state][dspst]=myline[2].asInt();
        else if(myline[1]=="Layerlock") 	mydata[temptab][index][state][lockd]=(myline[2].asInt()- 1);

		else if(myline[1]=="Layercamera")	mydata[temptab][index][state][uncam]=myline[2].asInt();
        else if(myline[1]=="Layerrays")		mydata[temptab][index][state][unray]=myline[2].asInt();
       	else if(myline[1]=="Layerfog")		mydata[temptab][index][state][unfog]=myline[2].asInt();
        else if(myline[1]=="Layerselfs")	mydata[temptab][index][state][selfs]=myline[2].asInt();
        else if(myline[1]=="Layercasts")	mydata[temptab][index][state][casts]=myline[2].asInt();
        else if(myline[1]=="Layerreces")	mydata[temptab][index][state][reces]=myline[2].asInt();
        else if(myline[1]=="Layermatte")	mydata[temptab][index][state][matte]=myline[2].asInt();

        else if(myline[1]=="MGHotkeysStart")
        {
			itemname=@"Meshes","Lights","Cameras","Bones"@;
			temp=io.read();
			myline=parse("^",temp);
			while(myline[1]!="MGHotkeysEnd")
			{
				hotkeyindex=myline[1].asInt();
				newhotkey=parse(":",myline[2]);
				if(hotkeys[hotkeyindex-HKStart]!=nil && hotkeys[hotkeyindex-HKStart]!=myline[2])
				{
					oldhotkey=parse(":",hotkeys[hotkeyindex-HKStart]);
					hotkeycode=hotkeyindex.asAsc();
					reqbegin("Replace '"+hotkeycode.asStr()+"' key assignment?");
					reqsize(200,100);
					c1=ctltext("Replace:",tabnames[oldhotkey[1]]+":"+oldhotkey[2]+":"+itemname[oldhotkey[3]]);
					c2=ctltext("With:",tabnames[newhotkey[1]]+":"+newhotkey[2]+":"+itemname[newhotkey[3]]);
					if(reqpost())
						hotkeys[hotkeyindex-HKStart]=myline[2];
					reqend();
				}
				else
                	hotkeys[hotkeyindex-HKStart]=myline[2];
				temp=io.read();
				myline=parse("^",temp);
			}
		}


        temp=io.read();
        myline=parse(" ",temp);
    }
    return(mydata);
}

//===================================================================================================================
// Render pass stuff.

SaveRenderScenes:all
{
//	currstate=CopyAllStates();
	tempsel=myselected;

	currentstates=MakeUncam();

	if (all)
	{
		for(i=1;i<=layers[rend].size();i++)
		{
			SaveRenderScene(i);
		}

		for(i=1;i<=layers[rend].size();i++)
		{
			myselected[i]=i;
		}
		ResetUncam(currentstates);
		myselected[i]=nil;
		StateTo(uncam,1);
		SaveRenderScene("Default");  // renders only items not in layers.
	}
	else
	{
		for(i=1;i<=tempsel.size();i++)
		{
			if(tempsel[i]==nil)
				break;
			SaveRenderScene(tempsel[i]);
		}

	}
	ResetUncam(currentstates);

	myselected=tempsel;
}

MakeUncam
{
	mymesh=Mesh();
	i=1;
	myitems;
	while(mymesh)
	{
		myitems[i][1]=mymesh;
		myitems[i][2]=mymesh.flags[4];
		if(!myitems[i][2])
		{
			SelectItem(mymesh.id);
			UnseenByCamera();
		}
		i++;
		mymesh=mymesh.next();
	}
	return(myitems);
}

ResetUncam:plist
{
	for(i=1;i<=plist.size();i++)
	{
		SelectItem(plist[i][1].id);
		mymesh=Scene().firstSelect();
		if(plist[i][2]!=mymesh.flags[4])
		{
			UnseenByCamera();
		}
	}
}

SelectAllLayers
{
	for(i=1;i<=layers[rend].size();i++)
	{
    	myselected[i]=i;
 	}
}

SaveRenderScene:layer
{
	if(layer!="Default")
	{
		renderlayers=layers[rend];
    	myselected[1]=layer;
    	myselected[2]=nil;
    	StateTo(uncam,0);
    	mylayer=renderlayers[layer];
		layername=mylayer[dname];
	}
	else
		layername="Default";
	myscenename=Scene().filename;
	myRGBname=Scene().rgbprefix;
	myalphaname=Scene().alphaprefix;


	if(myalphaname!="")
	{
		myname=MakeNewSavename(myalphaname,layername,layername,OUTPUTDIR);
		mycom="SaveAlphaPrefix "+myname;
		CommandInput(mycom);
 	}
	if(myRGBname!="")
	{
		myname=MakeNewSavename(myRGBname,layername,layername,OUTPUTDIR);
		mycom="SaveRGBPrefix "+myname;
		CommandInput(mycom);
 	}

 	myname=MakeNewSavename(myscenename,layername,"Layer",SCENESDIR);
	SaveSceneCopy(myname);

	if(layer!="Default") StateTo(uncam,1);
	if(myalphaname!="")
		CommandInput("SaveAlphaPrefix "+myalphaname);
	if(myRGBname!="")
		CommandInput("SaveRGBPrefix "+myRGBname);
}

MakeNewSavename:pstring,pnew,pdirname,pdir
{
	mydir=getdir(pdir);
	chdir(mydir);

	mkdir(pdirname);            // makesubdir
	mysplit=split(pstring);
	newname=mysplit[1]+mysplit[2]+pdirname+"\\"+mysplit[3]+"_"+pnew+mysplit[4];
	return(newname);
}

CopyAllStates
{
	for(j=1;j<=layers.size();j++)
	{
		for(i=1;i<=layers[j].size();i++)
		{
			states[j][i]=layers[j][i][state];
		}
	}
	return(states);
}



PasteAllStates:pstates
{
	for(j=1;j<=layers.size();j++)
	{
		for(i=1;i<=layers[j].size();i++)
		{
			layers[j][i][state]=pstates[j][i];
		}
	}
	return;
}



//========================================================================================================

// GENERIC UDFS

SelectAllLayers
{
	layerlist=layers[mytab];
	for(i=1;i<=layerlist.size();i++)
	{
		myselected[i]=i;
	}
}

SelectOld:olditems
{
    if(olditems)
    {
        SelectItem(olditems[1].id);
        for(i=1;i<=olditems.size();i++)
        {
            AddToSelection(olditems[i].id);
        }
    }
}

RemFromList : item, list
{
    if(!item)
        return(list);
    if(!list)
        return(nil);

    index=FindIndex(item,list);
    if(index==nil)
        return(list);

    p=1;
    for (i=1;i<index;i++)
    {
        templist[p]=list[i];
        p++;
    }
    for (i=index+1;i<=list.size();i++)
    {
        templist[p]=list[i];
        p++;
    }

    return(templist);
}

Help
{
    reqbegin("Help");
    reqsize(250,380);
    t2=ctltab("Layer>","Display","Render","Contact");
//=======================================================
//Layers tab
    lm1=ctltext("Create New Layer",
    "Adds a layer to the current layer menu");
    lm2=ctltext("Rename Layer",
    "Allows you to rename the selected layers");
    lm3=ctltext("View Contents of Layer",
    "Brings up a list of the items in the layer");
    lm4=ctltext("Choose Instance Name",
    "Because you can have more than one instance",
    "of LayersMC in the scene, you might want to",
    "have different LayersMC for different",
    "characters or something. This allows you to",
    "differentiate between them");
    lm5=ctltext("Clear layer items from scene",
    "Clears all the items of the layer from the scene");
    lm6=ctltext("Delete selected layers",
    "Deletes layers without removing the items in them");
    lm7=ctltext("Copy selected layers",
    "Copies selected layers");
    lm8=ctltext("Copy all layers",
    "Copies all layers");
    lm9=ctltext("Paste layers",
    "Appends copied layers to the layer list");
    ctlposition(lm1,10,30);
    ctlposition(lm2,10,60);
    ctlposition(lm3,10,90);
    ctlposition(lm4,10,120);
    ctlposition(lm5,10,200);
    ctlposition(lm6,10,230);
    ctlposition(lm7,10,260);
    ctlposition(lm8,10,290);
    ctlposition(lm9,10,320);
//==================================================================
//displaytab
    dl1=ctltext("Text/BBbox/Vrtex/FFace/Shade/Text",
    "Sets the items in the selected layers to the ",
    "required display type");
    dl2=ctltext("Lock/Unlk",
    "Locks or Unlocks the items in the selected layers");
    dl3=ctltext("O/B/L/C",
    "Selects either the Objects,Bones,Lights,or",
    "Cameras of the selected layers");
    dl4=ctltext("+ to Lyr/- to Lyr",
    "Adds or removes the selected items to the current",
    "layer");
    ctlposition(dl1,10,30);
    ctlposition(dl2,10,70);
    ctlposition(dl3,10,100);
    ctlposition(dl4,10,140);
//==================================================================
//rendertab
    rl1=ctltext("Camera/Rays",
    "Sets the items in the selected layers to be ",
    "seen by camera/rays");
    rl2=ctltext("SelfS/CastS/ReceS",
    "Sets the shadow options for the selected items");
    rl3=ctltext("O/B/L/C",
    "Selects either the Objects,Bones,Lights,or",
    "Cameras of the selected layers");
    rl4=ctltext("+ to Lyr/- to Lyr",
    "Adds or removes the selected items to the current",
    "layer");
    ctlposition(rl1,10,30);
    ctlposition(rl2,10,70);
    ctlposition(rl3,10,100);
    ctlposition(rl4,10,140);
//=================================================================
// Contacttab
    i1=ctltext("Contact","mike@mikegreen.name");
    ctlposition(i1,10,30);
//=================================================================

    ctlpage(1,lm1,lm2,lm3,lm4,lm5,lm6,lm7,lm8,lm9);
    ctlpage(2,dl1,dl2,dl3,dl4);
    ctlpage(3,rl1,rl2,rl3,rl4);
    ctlpage(4,i1);

    reqpost();

    reqend();
}

//========================================================================================================
//quicksort by id

Swap:a,b
{
    t=quicklist[a];
    quicklist[a]=quicklist[b];
    quicklist[b]=t; 
}

PartitionByID:left,right,pivind
{
    pivOA=quicklist[pivind];
    pivval=pivOA.id;
    Swap(pivind,right);
    storeind=left;
    for(i=left;i<=right - 1;i++)
    {
        if(quicklist[i].id<=pivval)
        {
            Swap(storeind,i);
            storeind++;
        }
    
    }
    Swap(right,storeind);
    return(storeind);
      
}

QSortByID:left,right
{
    if(right>left)
    {
        pivot=floor((right+left)/2);
        pivnew=PartitionByID(left,right,pivot);
        QSortByID(left,pivnew - 1);
        QSortByID(pivnew + 1, right);
    }
}

//==================================================================================================

ReduceList : list
{
    i=1;
    while(i<=list.size())
    {
        if(list[i]!=nil)
        {
            j=i+1;
            while(j<=list.size())
            {
                if (list[j]!=nil && list[j].id==list[i].id)
                {
                    list[j]=nil;
                }
                j++;            
            }
        }
        i++;
    }
    i=2;
    j=2;
    mytemp[1]=list[1];
//    get rid of nils

    while(i<=list.size())
    {
        if(list[i]!=nil)
        {
            mytemp[j]=list[i];
            j++;
        }
        i++;
    }

    return(mytemp);
}

FindIndex: item, list
{
    if (!item || !list )
        return nil;
    leftndx=1;
    rightndx=list.size();
    while(leftndx<=rightndx)
    {
        index=ceil((leftndx+rightndx)/2);
        if(list[index].id==item.id)
            return index;
        if(item.id<list[index].id)
            rightndx=index - 1;
        else
            leftndx=index + 1;
    }
    return nil;
}

GetAgentByID:id
{
    myitem=Mesh(id);
    if(!myitem)
    	myitem=Light(id);
    if(!myitem)
    	myitem=Camera(id);
    if(myitem)
    	return(myitem);
    else
    	return (nil);
}










